diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/model/lte-ue-rrc.cc ns-3.36/src/lte/model/lte-ue-rrc.cc
--- ns-3.35/src/lte/model/lte-ue-rrc.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/model/lte-ue-rrc.cc	2022-04-30 18:23:58.050734500 -0700
@@ -1896,330 +1909,475 @@
   ConcernedCells_t concernedCellsEntry;
   ConcernedCells_t concernedCellsLeaving;
 
-  switch (reportConfigEutra.eventId)
+  /*
+   * Find which serving cell corresponds to measObjectEutra.carrierFreq
+   * It is used, for example, by A1 event:
+   * See TS 36.331 5.5.4.2: "for this measurement, consider the primary or
+   * secondary cell that is configured on the frequency indicated in the
+   * associated measObjectEUTRA to be the serving cell"
+   */
+  uint16_t servingCellId = 0;
+  for (auto cphySapProvider: m_cphySapProvider)
     {
-      case LteRrcSap::ReportConfigEutra::EVENT_A1:
+      if (cphySapProvider->GetDlEarfcn () == measObjectEutra.carrierFreq)
         {
-          /*
-           * Event A1 (Serving becomes better than threshold)
-           * Please refer to 3GPP TS 36.331 Section 5.5.4.2
-           */
+          servingCellId = cphySapProvider->GetCellId ();
+        }
+    }
 
-          double ms; // Ms, the measurement result of the serving cell
-          double thresh; // Thresh, the threshold parameter for this event
-          // Hys, the hysteresis parameter for this event.
-          double hys = EutranMeasurementMapping::IeValue2ActualHysteresis (reportConfigEutra.hysteresis);
+  if (servingCellId == 0)
+    {
+      return;
+    }
 
-          switch (reportConfigEutra.triggerQuantity)
-            {
-              case LteRrcSap::ReportConfigEutra::RSRP:
-                ms = m_storedMeasValues[m_cellId].rsrp;
-                NS_ASSERT (reportConfigEutra.threshold1.choice
-                           == LteRrcSap::ThresholdEutra::THRESHOLD_RSRP);
-                thresh = EutranMeasurementMapping::RsrpRange2Dbm (reportConfigEutra.threshold1.range);
-                break;
-              case LteRrcSap::ReportConfigEutra::RSRQ:
-                ms = m_storedMeasValues[m_cellId].rsrq;
-                NS_ASSERT (reportConfigEutra.threshold1.choice
-                           == LteRrcSap::ThresholdEutra::THRESHOLD_RSRQ);
-                thresh = EutranMeasurementMapping::RsrqRange2Db (reportConfigEutra.threshold1.range);
-                break;
-              default:
-                NS_FATAL_ERROR ("unsupported triggerQuantity");
-                break;
-            }
+  switch (reportConfigEutra.eventId)
+    {
+    case LteRrcSap::ReportConfigEutra::EVENT_A1:
+      {
+        /*
+         * Event A1 (Serving becomes better than threshold)
+         * Please refer to 3GPP TS 36.331 Section 5.5.4.2
+         */
+
+        double ms; // Ms, the measurement result of the serving cell
+        double thresh; // Thresh, the threshold parameter for this event
+        // Hys, the hysteresis parameter for this event.
+        double hys = EutranMeasurementMapping::IeValue2ActualHysteresis (reportConfigEutra.hysteresis);
 
-          // Inequality A1-1 (Entering condition): Ms - Hys > Thresh
-          bool entryCond = ms - hys > thresh;
+        switch (reportConfigEutra.triggerQuantity)
+          {
+          case LteRrcSap::ReportConfigEutra::RSRP:
+            ms = m_storedMeasValues[servingCellId].rsrp;
 
-          if (entryCond)
-            {
-              if (!isMeasIdInReportList)
-                {
-                  concernedCellsEntry.push_back (m_cellId);
-                  eventEntryCondApplicable = true;
-                }
-              else
-                {
-                  /*
-                   * This is to check that the triggered cell recorded in the
-                   * VarMeasReportList is the serving cell.
-                   */
-                  NS_ASSERT (measReportIt->second.cellsTriggeredList.find (m_cellId)
-                             != measReportIt->second.cellsTriggeredList.end ());
-                }
-            }
-          else if (reportConfigEutra.timeToTrigger > 0)
-            {
-              CancelEnteringTrigger (measId);
-            }
+            NS_ASSERT (reportConfigEutra.threshold1.choice
+                       == LteRrcSap::ThresholdEutra::THRESHOLD_RSRP);
+            thresh = EutranMeasurementMapping::RsrpRange2Dbm (reportConfigEutra.threshold1.range);
+            break;
+          case LteRrcSap::ReportConfigEutra::RSRQ:
+            ms = m_storedMeasValues[servingCellId].rsrq;
+            NS_ASSERT (reportConfigEutra.threshold1.choice
+                       == LteRrcSap::ThresholdEutra::THRESHOLD_RSRQ);
+            thresh = EutranMeasurementMapping::RsrqRange2Db (reportConfigEutra.threshold1.range);
+            break;
+          default:
+            NS_FATAL_ERROR ("unsupported triggerQuantity");
+            break;
+          }
 
-          // Inequality A1-2 (Leaving condition): Ms + Hys < Thresh
-          bool leavingCond = ms + hys < thresh;
+        // Inequality A1-1 (Entering condition): Ms - Hys > Thresh
+        bool entryCond = ms - hys > thresh;
 
-          if (leavingCond)
-            {
-              if (isMeasIdInReportList)
-                {
-                  /*
-                   * This is to check that the triggered cell recorded in the
-                   * VarMeasReportList is the serving cell.
-                   */
-                  NS_ASSERT (measReportIt->second.cellsTriggeredList.find (m_cellId)
-                             != measReportIt->second.cellsTriggeredList.end ());
-                  concernedCellsLeaving.push_back (m_cellId);
-                  eventLeavingCondApplicable = true;
-                }
-            }
-          else if (reportConfigEutra.timeToTrigger > 0)
-            {
-              CancelLeavingTrigger (measId);
-            }
+        if (entryCond)
+          {
+            if (!isMeasIdInReportList)
+              {
+                concernedCellsEntry.push_back (servingCellId);
+                eventEntryCondApplicable = true;
+              }
+            else
+              {
+                /*
+                 * This is to check that the triggered cell recorded in the
+                 * VarMeasReportList is the serving cell.
+                 */
+                NS_ASSERT (measReportIt->second.cellsTriggeredList.find (servingCellId)
+                           != measReportIt->second.cellsTriggeredList.end ());
+              }
+          }
+        else if (reportConfigEutra.timeToTrigger > 0)
+          {
+            CancelEnteringTrigger (measId);
+          }
 
-          NS_LOG_LOGIC (this << " event A1: serving cell " << m_cellId
-                             << " ms=" << ms << " thresh=" << thresh
-                             << " entryCond=" << entryCond
-                             << " leavingCond=" << leavingCond);
+        // Inequality A1-2 (Leaving condition): Ms + Hys < Thresh
+        bool leavingCond = ms + hys < thresh;
 
-        } // end of case LteRrcSap::ReportConfigEutra::EVENT_A1
+        if (leavingCond)
+          {
+            if (isMeasIdInReportList)
+              {
+                /*
+                 * This is to check that the triggered cell recorded in the
+                 * VarMeasReportList is the serving cell.
+                 */
+                NS_ASSERT (measReportIt->second.cellsTriggeredList.find (m_cellId)
+                           != measReportIt->second.cellsTriggeredList.end ());
+                concernedCellsLeaving.push_back (m_cellId);
+                eventLeavingCondApplicable = true;
+              }
+          }
+        else if (reportConfigEutra.timeToTrigger > 0)
+          {
+            CancelLeavingTrigger (measId);
+          }
 
-        break;
+        NS_LOG_LOGIC (this << " event A1: serving cell " << servingCellId
+                           << " ms=" << ms << " thresh=" << thresh
+                           << " entryCond=" << entryCond
+                           << " leavingCond=" << leavingCond);
+
+      } // end of case LteRrcSap::ReportConfigEutra::EVENT_A1
+
+      break;
+
+    case LteRrcSap::ReportConfigEutra::EVENT_A2:
+      {
+        /*
+         * Event A2 (Serving becomes worse than threshold)
+         * Please refer to 3GPP TS 36.331 Section 5.5.4.3
+         */
+
+        double ms; // Ms, the measurement result of the serving cell
+        double thresh; // Thresh, the threshold parameter for this event
+        // Hys, the hysteresis parameter for this event.
+        double hys = EutranMeasurementMapping::IeValue2ActualHysteresis (reportConfigEutra.hysteresis);
 
-      case LteRrcSap::ReportConfigEutra::EVENT_A2:
-        {
-          /*
-           * Event A2 (Serving becomes worse than threshold)
-           * Please refer to 3GPP TS 36.331 Section 5.5.4.3
-           */
+        switch (reportConfigEutra.triggerQuantity)
+          {
+          case LteRrcSap::ReportConfigEutra::RSRP:
+            ms = m_storedMeasValues[servingCellId].rsrp;
+            NS_ASSERT (reportConfigEutra.threshold1.choice
+                       == LteRrcSap::ThresholdEutra::THRESHOLD_RSRP);
+            thresh = EutranMeasurementMapping::RsrpRange2Dbm (reportConfigEutra.threshold1.range);
+            break;
+          case LteRrcSap::ReportConfigEutra::RSRQ:
+            ms = m_storedMeasValues[servingCellId].rsrq;
+            NS_ASSERT (reportConfigEutra.threshold1.choice
+                       == LteRrcSap::ThresholdEutra::THRESHOLD_RSRQ);
+            thresh = EutranMeasurementMapping::RsrqRange2Db (reportConfigEutra.threshold1.range);
+            break;
+          default:
+            NS_FATAL_ERROR ("unsupported triggerQuantity");
+            break;
+          }
 
-          double ms; // Ms, the measurement result of the serving cell
-          double thresh; // Thresh, the threshold parameter for this event
-          // Hys, the hysteresis parameter for this event.
-          double hys = EutranMeasurementMapping::IeValue2ActualHysteresis (reportConfigEutra.hysteresis);
+        // Inequality A2-1 (Entering condition): Ms + Hys < Thresh
+        bool entryCond = ms + hys < thresh;
 
-          switch (reportConfigEutra.triggerQuantity)
-            {
+        if (entryCond)
+          {
+            if (!isMeasIdInReportList)
+              {
+                concernedCellsEntry.push_back (servingCellId);
+                eventEntryCondApplicable = true;
+              }
+            else
+              {
+                /*
+                 * This is to check that the triggered cell recorded in the
+                 * VarMeasReportList is the serving cell.
+                 */
+                NS_ASSERT (measReportIt->second.cellsTriggeredList.find (servingCellId)
+                           != measReportIt->second.cellsTriggeredList.end ());
+              }
+          }
+        else if (reportConfigEutra.timeToTrigger > 0)
+          {
+            CancelEnteringTrigger (measId);
+          }
+
+        // Inequality A2-2 (Leaving condition): Ms - Hys > Thresh
+        bool leavingCond = ms - hys > thresh;
+
+        if (leavingCond)
+          {
+            if (isMeasIdInReportList)
+              {
+                /*
+                 * This is to check that the triggered cell recorded in the
+                 * VarMeasReportList is the serving cell.
+                 */
+                NS_ASSERT (measReportIt->second.cellsTriggeredList.find (servingCellId)
+                           != measReportIt->second.cellsTriggeredList.end ());
+                concernedCellsLeaving.push_back (servingCellId);
+                eventLeavingCondApplicable = true;
+              }
+          }
+        else if (reportConfigEutra.timeToTrigger > 0)
+          {
+            CancelLeavingTrigger (measId);
+          }
+
+        NS_LOG_LOGIC (this << " event A2: serving cell " << servingCellId
+                           << " ms=" << ms << " thresh=" << thresh
+                           << " entryCond=" << entryCond
+                           << " leavingCond=" << leavingCond);
+
+      } // end of case LteRrcSap::ReportConfigEutra::EVENT_A2
+
+      break;
+
+    case LteRrcSap::ReportConfigEutra::EVENT_A3:
+      {
+        /*
+         * Event A3 (Neighbour becomes offset better than PCell)
+         * Please refer to 3GPP TS 36.331 Section 5.5.4.4
+         */
+
+        double mn; // Mn, the measurement result of the neighbouring cell
+        double ofn = measObjectEutra.offsetFreq; // Ofn, the frequency specific offset of the frequency of the
+        double ocn = 0.0; // Ocn, the cell specific offset of the neighbour cell
+        double mp; // Mp, the measurement result of the PCell
+        double ofp = measObjectEutra.offsetFreq; // Ofp, the frequency specific offset of the primary frequency
+        double ocp = 0.0; // Ocp, the cell specific offset of the PCell
+        // Off, the offset parameter for this event.
+        double off = EutranMeasurementMapping::IeValue2ActualA3Offset (reportConfigEutra.a3Offset);
+        // Hys, the hysteresis parameter for this event.
+        double hys = EutranMeasurementMapping::IeValue2ActualHysteresis (reportConfigEutra.hysteresis);
+
+        switch (reportConfigEutra.triggerQuantity)
+          {
+          case LteRrcSap::ReportConfigEutra::RSRP:
+            mp = m_storedMeasValues[m_cellId].rsrp;
+            NS_ASSERT (reportConfigEutra.threshold1.choice
+                       == LteRrcSap::ThresholdEutra::THRESHOLD_RSRP);
+            break;
+          case LteRrcSap::ReportConfigEutra::RSRQ:
+            mp = m_storedMeasValues[m_cellId].rsrq;
+            NS_ASSERT (reportConfigEutra.threshold1.choice
+                       == LteRrcSap::ThresholdEutra::THRESHOLD_RSRQ);
+            break;
+          default:
+            NS_FATAL_ERROR ("unsupported triggerQuantity");
+            break;
+          }
+
+        for (std::map<uint16_t, MeasValues>::iterator storedMeasIt = m_storedMeasValues.begin ();
+             storedMeasIt != m_storedMeasValues.end ();
+             ++storedMeasIt)
+          {
+            uint16_t cellId = storedMeasIt->first;
+            if (cellId == m_cellId)
+              {
+                continue;
+              }
+
+            // Only cell(s) on the frequency indicated in the associated measObject can trigger event.
+            if (m_storedMeasValues.at (cellId).carrierFreq != measObjectEutra.carrierFreq)
+              {
+                continue;
+              }
+
+            switch (reportConfigEutra.triggerQuantity)
+              {
               case LteRrcSap::ReportConfigEutra::RSRP:
-                ms = m_storedMeasValues[m_cellId].rsrp;
-                NS_ASSERT (reportConfigEutra.threshold1.choice
-                           == LteRrcSap::ThresholdEutra::THRESHOLD_RSRP);
-                thresh = EutranMeasurementMapping::RsrpRange2Dbm (reportConfigEutra.threshold1.range);
+                mn = storedMeasIt->second.rsrp;
                 break;
               case LteRrcSap::ReportConfigEutra::RSRQ:
-                ms = m_storedMeasValues[m_cellId].rsrq;
-                NS_ASSERT (reportConfigEutra.threshold1.choice
-                           == LteRrcSap::ThresholdEutra::THRESHOLD_RSRQ);
-                thresh = EutranMeasurementMapping::RsrqRange2Db (reportConfigEutra.threshold1.range);
+                mn = storedMeasIt->second.rsrq;
                 break;
               default:
                 NS_FATAL_ERROR ("unsupported triggerQuantity");
                 break;
-            }
-
-          // Inequality A2-1 (Entering condition): Ms + Hys < Thresh
-          bool entryCond = ms + hys < thresh;
+              }
 
-          if (entryCond)
-            {
-              if (!isMeasIdInReportList)
-                {
-                  concernedCellsEntry.push_back (m_cellId);
-                  eventEntryCondApplicable = true;
-                }
-              else
-                {
-                  /*
-                   * This is to check that the triggered cell recorded in the
-                   * VarMeasReportList is the serving cell.
-                   */
-                  NS_ASSERT (measReportIt->second.cellsTriggeredList.find (m_cellId)
-                             != measReportIt->second.cellsTriggeredList.end ());
-                }
-            }
-          else if (reportConfigEutra.timeToTrigger > 0)
-            {
-              CancelEnteringTrigger (measId);
-            }
+            bool hasTriggered = isMeasIdInReportList
+              && (measReportIt->second.cellsTriggeredList.find (cellId)
+                  != measReportIt->second.cellsTriggeredList.end ());
 
-          // Inequality A2-2 (Leaving condition): Ms - Hys > Thresh
-          bool leavingCond = ms - hys > thresh;
+            // Inequality A3-1 (Entering condition): Mn + Ofn + Ocn - Hys > Mp + Ofp + Ocp + Off
+            bool entryCond = mn + ofn + ocn - hys > mp + ofp + ocp + off;
 
-          if (leavingCond)
-            {
-              if (isMeasIdInReportList)
-                {
-                  /*
-                   * This is to check that the triggered cell recorded in the
-                   * VarMeasReportList is the serving cell.
-                   */
-                  NS_ASSERT (measReportIt->second.cellsTriggeredList.find (m_cellId)
-                             != measReportIt->second.cellsTriggeredList.end ());
-                  concernedCellsLeaving.push_back (m_cellId);
-                  eventLeavingCondApplicable = true;
-                }
-            }
-          else if (reportConfigEutra.timeToTrigger > 0)
-            {
-              CancelLeavingTrigger (measId);
-            }
+            if (entryCond)
+              {
+                if (!hasTriggered)
+                  {
+                    concernedCellsEntry.push_back (cellId);
+                    eventEntryCondApplicable = true;
+                  }
+              }
+            else if (reportConfigEutra.timeToTrigger > 0)
+              {
+                CancelEnteringTrigger (measId, cellId);
+              }
 
-          NS_LOG_LOGIC (this << " event A2: serving cell " << m_cellId
-                             << " ms=" << ms << " thresh=" << thresh
-                             << " entryCond=" << entryCond
-                             << " leavingCond=" << leavingCond);
+            // Inequality A3-2 (Leaving condition): Mn + Ofn + Ocn + Hys < Mp + Ofp + Ocp + Off
+            bool leavingCond = mn + ofn + ocn + hys < mp + ofp + ocp + off;
 
-        } // end of case LteRrcSap::ReportConfigEutra::EVENT_A2
+            if (leavingCond)
+              {
+                if (hasTriggered)
+                  {
+                    concernedCellsLeaving.push_back (cellId);
+                    eventLeavingCondApplicable = true;
+                  }
+              }
+            else if (reportConfigEutra.timeToTrigger > 0)
+              {
+                CancelLeavingTrigger (measId, cellId);
+              }
 
-        break;
+            NS_LOG_LOGIC (this << " event A3: neighbor cell " << cellId
+                               << " mn=" << mn << " mp=" << mp << " offset=" << off
+                               << " entryCond=" << entryCond
+                               << " leavingCond=" << leavingCond);
+
+          } // end of for (storedMeasIt)
+
+      } // end of case LteRrcSap::ReportConfigEutra::EVENT_A3
+
+      break;
+
+    case LteRrcSap::ReportConfigEutra::EVENT_A4:
+      {
+        /*
+         * Event A4 (Neighbour becomes better than threshold)
+         * Please refer to 3GPP TS 36.331 Section 5.5.4.5
+         */
+
+        double mn; // Mn, the measurement result of the neighbouring cell
+        double ofn = measObjectEutra.offsetFreq; // Ofn, the frequency specific offset of the frequency of the
+        double ocn = 0.0; // Ocn, the cell specific offset of the neighbour cell
+        double thresh; // Thresh, the threshold parameter for this event
+        // Hys, the hysteresis parameter for this event.
+        double hys = EutranMeasurementMapping::IeValue2ActualHysteresis (reportConfigEutra.hysteresis);
 
-      case LteRrcSap::ReportConfigEutra::EVENT_A3:
-        {
-          /*
-           * Event A3 (Neighbour becomes offset better than PCell)
-           * Please refer to 3GPP TS 36.331 Section 5.5.4.4
-           */
+        switch (reportConfigEutra.triggerQuantity)
+          {
+          case LteRrcSap::ReportConfigEutra::RSRP:
+            NS_ASSERT (reportConfigEutra.threshold1.choice
+                       == LteRrcSap::ThresholdEutra::THRESHOLD_RSRP);
+            thresh = EutranMeasurementMapping::RsrpRange2Dbm (reportConfigEutra.threshold1.range);
+            break;
+          case LteRrcSap::ReportConfigEutra::RSRQ:
+            NS_ASSERT (reportConfigEutra.threshold1.choice
+                       == LteRrcSap::ThresholdEutra::THRESHOLD_RSRQ);
+            thresh = EutranMeasurementMapping::RsrqRange2Db (reportConfigEutra.threshold1.range);
+            break;
+          default:
+            NS_FATAL_ERROR ("unsupported triggerQuantity");
+            break;
+          }
 
-          double mn; // Mn, the measurement result of the neighbouring cell
-          double ofn = measObjectEutra.offsetFreq; // Ofn, the frequency specific offset of the frequency of the
-          double ocn = 0.0; // Ocn, the cell specific offset of the neighbour cell
-          double mp; // Mp, the measurement result of the PCell
-          double ofp = measObjectEutra.offsetFreq; // Ofp, the frequency specific offset of the primary frequency
-          double ocp = 0.0; // Ocp, the cell specific offset of the PCell
-          // Off, the offset parameter for this event.
-          double off = EutranMeasurementMapping::IeValue2ActualA3Offset (reportConfigEutra.a3Offset);
-          // Hys, the hysteresis parameter for this event.
-          double hys = EutranMeasurementMapping::IeValue2ActualHysteresis (reportConfigEutra.hysteresis);
+        for (std::map<uint16_t, MeasValues>::iterator storedMeasIt = m_storedMeasValues.begin ();
+             storedMeasIt != m_storedMeasValues.end ();
+             ++storedMeasIt)
+          {
+            uint16_t cellId = storedMeasIt->first;
+            if (cellId == m_cellId)
+              {
+                continue;
+              }
 
-          switch (reportConfigEutra.triggerQuantity)
-            {
+            switch (reportConfigEutra.triggerQuantity)
+              {
               case LteRrcSap::ReportConfigEutra::RSRP:
-                mp = m_storedMeasValues[m_cellId].rsrp;
-                NS_ASSERT (reportConfigEutra.threshold1.choice
-                           == LteRrcSap::ThresholdEutra::THRESHOLD_RSRP);
+                mn = storedMeasIt->second.rsrp;
                 break;
               case LteRrcSap::ReportConfigEutra::RSRQ:
-                mp = m_storedMeasValues[m_cellId].rsrq;
-                NS_ASSERT (reportConfigEutra.threshold1.choice
-                           == LteRrcSap::ThresholdEutra::THRESHOLD_RSRQ);
+                mn = storedMeasIt->second.rsrq;
                 break;
               default:
                 NS_FATAL_ERROR ("unsupported triggerQuantity");
                 break;
-            }
-
-          for (std::map<uint16_t, MeasValues>::iterator storedMeasIt = m_storedMeasValues.begin ();
-               storedMeasIt != m_storedMeasValues.end ();
-               ++storedMeasIt)
-            {
-              uint16_t cellId = storedMeasIt->first;
-              if (cellId == m_cellId)
-                {
-                  continue;
-                }
-
-              switch (reportConfigEutra.triggerQuantity)
-                {
-                  case LteRrcSap::ReportConfigEutra::RSRP:
-                    mn = storedMeasIt->second.rsrp;
-                    break;
-                  case LteRrcSap::ReportConfigEutra::RSRQ:
-                    mn = storedMeasIt->second.rsrq;
-                    break;
-                  default:
-                    NS_FATAL_ERROR ("unsupported triggerQuantity");
-                    break;
-                }
-
-              bool hasTriggered = isMeasIdInReportList
-                && (measReportIt->second.cellsTriggeredList.find (cellId)
-                    != measReportIt->second.cellsTriggeredList.end ());
-
-              // Inequality A3-1 (Entering condition): Mn + Ofn + Ocn - Hys > Mp + Ofp + Ocp + Off
-              bool entryCond = mn + ofn + ocn - hys > mp + ofp + ocp + off;
-
-              if (entryCond)
-                {
-                  if (!hasTriggered)
-                    {
-                      concernedCellsEntry.push_back (cellId);
-                      eventEntryCondApplicable = true;
-                    }
-                }
-              else if (reportConfigEutra.timeToTrigger > 0)
-                {
-                  CancelEnteringTrigger (measId, cellId);
-                }
-
-              // Inequality A3-2 (Leaving condition): Mn + Ofn + Ocn + Hys < Mp + Ofp + Ocp + Off
-              bool leavingCond = mn + ofn + ocn + hys < mp + ofp + ocp + off;
+              }
 
-              if (leavingCond)
-                {
-                  if (hasTriggered)
-                    {
-                      concernedCellsLeaving.push_back (cellId);
-                      eventLeavingCondApplicable = true;
-                    }
-                }
-              else if (reportConfigEutra.timeToTrigger > 0)
-                {
-                  CancelLeavingTrigger (measId, cellId);
-                }
+            bool hasTriggered = isMeasIdInReportList
+              && (measReportIt->second.cellsTriggeredList.find (cellId)
+                  != measReportIt->second.cellsTriggeredList.end ());
 
-              NS_LOG_LOGIC (this << " event A3: neighbor cell " << cellId
-                                 << " mn=" << mn << " mp=" << mp << " offset=" << off
-                                 << " entryCond=" << entryCond
-                                 << " leavingCond=" << leavingCond);
+            // Inequality A4-1 (Entering condition): Mn + Ofn + Ocn - Hys > Thresh
+            bool entryCond = mn + ofn + ocn - hys > thresh;
 
-            } // end of for (storedMeasIt)
+            if (entryCond)
+              {
+                if (!hasTriggered)
+                  {
+                    concernedCellsEntry.push_back (cellId);
+                    eventEntryCondApplicable = true;
+                  }
+              }
+            else if (reportConfigEutra.timeToTrigger > 0)
+              {
+                CancelEnteringTrigger (measId, cellId);
+              }
 
-        } // end of case LteRrcSap::ReportConfigEutra::EVENT_A3
+            // Inequality A4-2 (Leaving condition): Mn + Ofn + Ocn + Hys < Thresh
+            bool leavingCond = mn + ofn + ocn + hys < thresh;
 
-        break;
+            if (leavingCond)
+              {
+                if (hasTriggered)
+                  {
+                    concernedCellsLeaving.push_back (cellId);
+                    eventLeavingCondApplicable = true;
+                  }
+              }
+            else if (reportConfigEutra.timeToTrigger > 0)
+              {
+                CancelLeavingTrigger (measId, cellId);
+              }
 
-      case LteRrcSap::ReportConfigEutra::EVENT_A4:
-        {
-          /*
-           * Event A4 (Neighbour becomes better than threshold)
-           * Please refer to 3GPP TS 36.331 Section 5.5.4.5
-           */
+            NS_LOG_LOGIC (this << " event A4: neighbor cell " << cellId
+                               << " mn=" << mn << " thresh=" << thresh
+                               << " entryCond=" << entryCond
+                               << " leavingCond=" << leavingCond);
+
+          } // end of for (storedMeasIt)
+
+      } // end of case LteRrcSap::ReportConfigEutra::EVENT_A4
+
+      break;
+
+    case LteRrcSap::ReportConfigEutra::EVENT_A5:
+      {
+        /*
+         * Event A5 (PCell becomes worse than threshold1 and neighbour
+         * becomes better than threshold2)
+         * Please refer to 3GPP TS 36.331 Section 5.5.4.6
+         */
+
+        double mp; // Mp, the measurement result of the PCell
+        double mn; // Mn, the measurement result of the neighbouring cell
+        double ofn = measObjectEutra.offsetFreq; // Ofn, the frequency specific offset of the frequency of the
+        double ocn = 0.0; // Ocn, the cell specific offset of the neighbour cell
+        double thresh1; // Thresh1, the threshold parameter for this event
+        double thresh2; // Thresh2, the threshold parameter for this event
+        // Hys, the hysteresis parameter for this event.
+        double hys = EutranMeasurementMapping::IeValue2ActualHysteresis (reportConfigEutra.hysteresis);
 
-          double mn; // Mn, the measurement result of the neighbouring cell
-          double ofn = measObjectEutra.offsetFreq; // Ofn, the frequency specific offset of the frequency of the
-          double ocn = 0.0; // Ocn, the cell specific offset of the neighbour cell
-          double thresh; // Thresh, the threshold parameter for this event
-          // Hys, the hysteresis parameter for this event.
-          double hys = EutranMeasurementMapping::IeValue2ActualHysteresis (reportConfigEutra.hysteresis);
+        switch (reportConfigEutra.triggerQuantity)
+          {
+          case LteRrcSap::ReportConfigEutra::RSRP:
+            mp = m_storedMeasValues[m_cellId].rsrp;
+            NS_ASSERT (reportConfigEutra.threshold1.choice
+                       == LteRrcSap::ThresholdEutra::THRESHOLD_RSRP);
+            NS_ASSERT (reportConfigEutra.threshold2.choice
+                       == LteRrcSap::ThresholdEutra::THRESHOLD_RSRP);
+            thresh1 = EutranMeasurementMapping::RsrpRange2Dbm (reportConfigEutra.threshold1.range);
+            thresh2 = EutranMeasurementMapping::RsrpRange2Dbm (reportConfigEutra.threshold2.range);
+            break;
+          case LteRrcSap::ReportConfigEutra::RSRQ:
+            mp = m_storedMeasValues[m_cellId].rsrq;
+            NS_ASSERT (reportConfigEutra.threshold1.choice
+                       == LteRrcSap::ThresholdEutra::THRESHOLD_RSRQ);
+            NS_ASSERT (reportConfigEutra.threshold2.choice
+                       == LteRrcSap::ThresholdEutra::THRESHOLD_RSRQ);
+            thresh1 = EutranMeasurementMapping::RsrqRange2Db (reportConfigEutra.threshold1.range);
+            thresh2 = EutranMeasurementMapping::RsrqRange2Db (reportConfigEutra.threshold2.range);
+            break;
+          default:
+            NS_FATAL_ERROR ("unsupported triggerQuantity");
+            break;
+          }
 
-          switch (reportConfigEutra.triggerQuantity)
-            {
-              case LteRrcSap::ReportConfigEutra::RSRP:
-                NS_ASSERT (reportConfigEutra.threshold1.choice
-                           == LteRrcSap::ThresholdEutra::THRESHOLD_RSRP);
-                thresh = EutranMeasurementMapping::RsrpRange2Dbm (reportConfigEutra.threshold1.range);
-                break;
-              case LteRrcSap::ReportConfigEutra::RSRQ:
-                NS_ASSERT (reportConfigEutra.threshold1.choice
-                           == LteRrcSap::ThresholdEutra::THRESHOLD_RSRQ);
-                thresh = EutranMeasurementMapping::RsrqRange2Db (reportConfigEutra.threshold1.range);
-                break;
-              default:
-                NS_FATAL_ERROR ("unsupported triggerQuantity");
-                break;
-            }
+        // Inequality A5-1 (Entering condition 1): Mp + Hys < Thresh1
+        bool entryCond = mp + hys < thresh1;
 
-          for (std::map<uint16_t, MeasValues>::iterator storedMeasIt = m_storedMeasValues.begin ();
-               storedMeasIt != m_storedMeasValues.end ();
-               ++storedMeasIt)
-            {
-              uint16_t cellId = storedMeasIt->first;
-              if (cellId == m_cellId)
-                {
-                  continue;
-                }
+        if (entryCond)
+          {
+            for (std::map<uint16_t, MeasValues>::iterator storedMeasIt = m_storedMeasValues.begin ();
+                 storedMeasIt != m_storedMeasValues.end ();
+                 ++storedMeasIt)
+              {
+                uint16_t cellId = storedMeasIt->first;
+                if (cellId == m_cellId)
+                  {
+                    continue;
+                  }
 
-              switch (reportConfigEutra.triggerQuantity)
-                {
+                switch (reportConfigEutra.triggerQuantity)
+                  {
                   case LteRrcSap::ReportConfigEutra::RSRP:
                     mn = storedMeasIt->second.rsrp;
                     break;
